'use strict';

const fs = require('fs');

class FsUtils {

    /**
     * Returns a list of directory files
     *
     * @param dir
     * @returns {Array}
     */
    listFolderFiles(dir) {
        let result = [];

        fs.readdirSync(dir).forEach((filename) => {
            let file = dir.replace(/\/+$/, '') + '/' + filename;

            if(fs.statSync(file).isDirectory()) {
                return;
            }

            result.push(file);
        });

        return result;
    }
}

module.exports = new FsUtils;