'use strict';

class Reflection {

    /**
     * @see https://stackoverflow.com/questions/1007981/how-to-get-function-parameter-names-values-dynamically
     * @param fnc
     * @return {Array}
     */
    getFunctionParams(fnc) {
        let STRIP_COMMENTS = /((\/\/.*$)|(\/\*[\s\S]*?\*\/))/mg;
        let ARGUMENT_NAMES = /([^\s,]+)/g;

        let fnStr = fnc.toString().replace(STRIP_COMMENTS, '');
        let result = fnStr.slice(fnStr.indexOf('(') + 1, fnStr.indexOf(')')).match(ARGUMENT_NAMES);

        if(result === null) {
            result = [];
        }

        return result;
    }

    applyMapping(fnc, scope, args) {
        let params = this.getFunctionParams(fnc);

        let mapArgs = [];

        params.forEach(param => {
            // include undefined values
            mapArgs.push(args[param]);
        });

        return fnc.apply(scope, mapArgs);
    }

}

module.exports = new Reflection();