'use strict';

const chai = require('chai');
const mocha = require('mocha');
const should = require('should');

const util = require('util');
const __ = require('../index');

describe('Object', function() {
    this.timeout(10 * 1000);

    /* -------------------------------------------------------------------------
     * Class
     * ---------------------------------------------------------------------- */

    class Model {
        constructor(data) {
            this.fields = data || {};
        }

        toArray() {
            return this.fields;
        }
    }

    /* -------------------------------------------------------------------------
     * Before
     * ---------------------------------------------------------------------- */

    before(function() {
    });

    /* -------------------------------------------------------------------------
     * Create
     * ---------------------------------------------------------------------- */

    describe('simplify', () => {

        it('normal', () => {
            let obj = [
                {
                    name: 'test name',
                    result: [
                        new Model({
                            a: 222,
                        })
                    ],
                    offer: {
                        offers: {
                            offers: [
                                {
                                    name: 'offer name',
                                    by: new Model({
                                        provider: 'test',
                                        url: 'test url',
                                        test: [
                                            new Model({
                                                a: 123,
                                                b: 123,
                                            }),
                                            new Model({
                                                a: 123,
                                                b: new Model({
                                                    c: 222,
                                                }),
                                            })
                                        ]
                                    })
                                }
                            ]
                        }
                    }
                }
            ];

            let res = __.object.simplify(obj);

            console.info(util.inspect(obj, null, 100, true));
            console.info(util.inspect(res, null, 100, true));
        });
    });

});